package Model.Baum;


/**
 * Ein sortierter Bin&auml;rbaum nach Standardimplementierung.
 * 
 * @author ISB-Arbeitskreis, Umsetzungshilfen Informatik 12 
 * @version 1.0
 */
public class BAUM
{
    /* Referenz auf die Wurzel des Baums. */
    private BAUMELEMENT anfang;
    /* Zauml;hler f&uuml;r die Anzahl der Vergleiche */
    private static int zaehler;

    /**
     * Legt einen leeren Baum an.
     */
    public BAUM ()
    {
        anfang = new ABSCHLUSS ();
    }


    /**
     * F&uuml;gt ein neues Datenelement in den Baum ein.
     * @param neu Referenz auf des neue Datenelement
     */
    public void Einfuegen (Model. DATENELEMENT neu)
    {
        anfang = anfang. Einfuegen (neu);
    }
    
    /**
     * Sucht ein Datenelement mit dem in der Referenz angegebenen Schl&uuml;ssel.
     * @param schluessel Referenz auf ein Datenelement mit dem zu suchenden Schl&uuml;sselwert
     * @return das gefundene Datenelement oder null
     */
    public Model. DATENELEMENT Suchen (Model. DATENELEMENT schluessel)
    {
        zaehler = 0;
        return anfang. Suchen (schluessel);
    }
    
    /**
     * Erh&ouml;ht den Z&auml;hler um 1.
     */
    static void ZaehlerErhoehen ()
    {
        zaehler += 1;
    }
    
    /**
     * Meldet den Z&auml;hlerstand.
     * @return Z&auml;hlerstand
     */
    public static int ZaehlerGeben ()
    {
        return zaehler;
    }
}
